/*******************************************************************************
 * FoxStorePreviewNode_WeaponBase generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxStorePreviewNode_WeaponBase extends FoxStorePreviewNode_PreviewBase within FoxStoreUIItemDetail
    config(UI);

var FoxArmoryUI.EWeaponCustomizationItem CustomItemType;
var FoxWeaponConfigInfo WeaponConfig;
var FoxWeaponModInfo WeaponModInfo;
var const bool bSnapToLocation;

function ApplyItemStats()
{
    local array<StatPanelEntry> StatData;
    local array<Vector2D> OrigStats, NewStats;

    switch(Outer.PreviewNodeType)
    {
        // End:0x2D
        case 19:
        // End:0x143
        case 26:
            class'FoxStatsUI'.static.GetWeaponStats(OrigStats, FoxPRI(Outer.Outer.Outer.Outer.PCOwner.PlayerReplicationInfo).Loadout, WeaponConfig);
            NewStats = OrigStats;
            class'FoxStatsUI'.static.GetFormattedWeaponStats(StatData, OrigStats, NewStats);
            // End:0x182
            break;
        // End:0x14B
        case 9:
            // End:0x182
            break;
        // End:0xFFFF
        default:
            class'FoxStatsUI'.static.GetFormattedStatsFromWeaponModifiers(StatData, WeaponModInfo);
            // End:0x182
            break;
    }
    // End:0x1BA
    if(StatData.Length > 0)
    {
        Outer.as_addStoreDetailStats(StatData);
    }
    //return;    
}

function MakePreviewActor()
{
    local bool bValidLocation;
    local Vector CamOffset, RotatedOffset;
    local float CamDistance;

    SetupWeaponConfig(WeaponConfig);
    // End:0x4F0
    if((FoxCustomWeaponActor(Outer.PreviewActor) == none) || WeaponConfig.WeaponClass != FoxCustomWeaponActor(Outer.PreviewActor).CurrentWeaponInfo.WeaponClass)
    {
        // End:0x204
        if(Outer.PreviewActor != none)
        {
            // End:0x1D7
            if((FoxCustomWeaponActor(Outer.PreviewActor) != none) && !bSnapToLocation)
            {
                CamOffset = Outer.PreviewActor.CameraOffset;
                CamDistance = Outer.PreviewActor.CameraDistance;
                RotatedOffset = Outer.PreviewActor.RotatedOffset;
                bValidLocation = true;
            }
            Outer.PreviewActor.Destroy();
        }
        Outer.PreviewActor = Outer.Outer.Outer.Outer.PCOwner.Spawn(class'FoxCustomWeaponActor', Outer.Outer.Outer.Outer.PCOwner,, Outer.PreviewSpawnPoint.Location, Outer.PreviewSpawnPoint.Rotation);
        Outer.PreviewActor.OwnerPC = Outer.Outer.Outer.Outer.PCOwner;
        // End:0x4F0
        if(bValidLocation)
        {
            Outer.PreviewActor.CameraOffset = CamOffset;
            Outer.PreviewActor.CameraDistance = CamDistance;
            Outer.PreviewActor.RotatedOffset = RotatedOffset;
            Outer.PreviewActor.bValidLocation = true;
        }
    }
    Outer.PreviewActor.CustomItemType = GetCustomItemType();
    Outer.PreviewActor.HighlightItemType = GetCustomItemType();
    FoxCustomWeaponActor(Outer.PreviewActor).UpdateConfigInfo(WeaponConfig);
    Outer.PreviewActor.MoveWeaponToIdealPosition(float(WeaponXPos), float(WeaponYPos), float(WeaponWidth), float(WeaponHeight));
    Outer.Outer.Outer.Outer.PCOwner.SetViewTarget(Outer.PreviewActor);
    Outer.Outer.Outer.Outer.PCOwner.PlayerCamera.DoUpdateCamera(0.0);
    ApplyItemStats();
    //return;    
}

function SetupWeaponConfig(out FoxWeaponConfigInfo ConfigInfo)
{
    //return;    
}

function FoxArmoryUI.EWeaponCustomizationItem GetCustomItemType()
{
    switch(Outer.PreviewNodeType)
    {
        // End:0x30
        case 19:
            return 0;
        // End:0x38
        case 26:
            return 1;
        // End:0x40
        case 27:
            return 3;
        // End:0x48
        case 29:
            return 2;
        // End:0x50
        case 32:
            return 6;
        // End:0x58
        case 28:
            return 7;
        // End:0x60
        case 30:
            return 5;
        // End:0x68
        case 44:
            return 4;
        // End:0x70
        case 9:
            return 9;
        // End:0xFFFF
        default:
            return 0;
    }
    //return ReturnValue;    
}

defaultproperties
{
    WeaponConfig=(WeaponSkin=255,WeaponClass=none,WeaponMuzzle=255,WeaponStock=none,WeaponBarrel=none,WeaponMagazine=255,WeaponScope=none,WeaponHanger=0,WeaponGrip=none,WeaponAmmo=none,WeaponCamoIndex=0)
}